Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34921)
@@ -6757,4 +9694,112 @@
 
 #------------------------------------------------------------------------------
+# Read CMT3 maker notes from CR3 file
+# Inputs: 0) ExifTool object reference, 1) dirInfo ref, 2) tag table ref
+# Returns: data block (may be empty if no Exif data) or undef on error
+sub ProcessCMT3($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+
+    # extract the static maker notes to copying to other file types if requested
+    # Note: this won't copy makernotes in the timed metadata since these are stored
+    # separately, but the only records they have that aren't in the static maker notes
+    # (for the M50) are: ColorData9, Flavor, CanonCameraInfoUnknown,
+    # VignettingCorrUnknown1, Canon_0x4033 and Canon_0x402e
+    if (($et->Options('MakerNotes') or $$et{REQ_TAG_LOOKUP}{makernotecanon}) and
+        $$dirInfo{DirLen} > 8)
+    {
+        my $dataPt = $$dirInfo{DataPt};
+        # remove old (unused) trailer
+        $$dataPt =~ s/(II\x2a\0|MM\0\x2a)\0{4,10}$//;
+        # remove TIFF header and append as the Canon makernote trailer
+        # (so offsets will be interpreted correctly)
+        my $val = substr($$dataPt,8) . substr($$dataPt,0,8);
+        $et->FoundTag($Image::ExifTool::Canon::uuid{CMT3}, \$val);
+    }
+    return $et->ProcessTIFF($dirInfo, $tagTablePtr);
+}
+
+#------------------------------------------------------------------------------
+# Process CTMD EXIF information
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub ProcessExifInfo($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $start = $$dirInfo{DirStart} || 0;
+    my $dirLen = $$dirInfo{DirLen} || (length($$dataPt) - $start);
+    my $dirEnd = $start + $dirLen;
+    # loop through TIFF-format EXIF/MakerNote records
+    my ($pos, $len, $tag);
+    for ($pos = $start; $pos + 8 < $dirEnd; $pos += $len) {
+        $len = Get32u($dataPt, $pos);
+        $tag = Get32u($dataPt, $pos + 4);
+        # test size/tag for valid ExifInfo (not EXIF in CRM files)
+        last if $len < 8 or $pos + $len > $dirEnd or not $$tagTablePtr{$tag};
+        $et->VerboseDir('ExifInfo', undef, $dirLen) if $pos == $start;
+        $et->HandleTag($tagTablePtr, $tag, undef,
+            DataPt  => $dataPt,
+            Base    => $$dirInfo{Base} + $pos + 8, # base for TIFF pointers
+            DataPos => -($pos + 8), # (relative to Base)
+            Start   => $pos + 8,
+            Size    => $len - 8,
+        );
+    }
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# Process Canon Timed MetaData (ref PH)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success
+sub ProcessCTMD($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $verbose = $et->Options('Verbose');
+    my $dirLen = length $$dataPt;
+    my $pos = 0;
+    SetByteOrder('II');
+    while ($pos + 6 < $dirLen) {
+        my $size = Get32u($dataPt, $pos);
+        my $type = Get16u($dataPt, $pos + 4);
+        # what is the meaning of the 6-byte header of these records?:
+        #  type 1 - 00 00 00 01 zz zz - TimeStamp(CR3/CRM); zz=00(CR3),ff(CRM)
+        #  type 3 - 00 00 00 01 zz zz - ? "ff ff ff ff"; zz=00(CR3),ff(CRM)
+        #  type 4 - 00 00 00 01 ff ff - FocalInfo(CR3/CRM)
+        #  type 5 - 00 00 00 01 ff ff - ExposureInfo(CR3/CRM)
+        #  type 6 - 00 04 00 01 ff ff - ? "03 04 00 80 e0 15 ff ff"(CRM) [0x15e0 = ColorTemperature?]
+        #  type 7 - xx yy 00 01 ff ff - ExifIFD + MakerNotes(CR3), ?(CRM); xxyy=0101(CR3),0004(CRM)
+        #  type 8 - 01 yy 00 01 ff ff - MakerNotes(CR3), ?(CRM); yy=01(CR3),04(CRM)
+        #  type 9 - 01 yy 00 01 ff ff - MakerNotes(CR3), ?(CRM); yy=01(CR3),00(CRM)
+        #  type 10- 01 00 00 01 ff ff - ? (CRM)
+        #  type 11- 01 00 00 01 ff ff - ? (CRM)
+        # --> maybe yy == 01 for ExifInfo?
+        $size < 12 and $et->Warn('Short CTMD record'), last;
+        $pos + $size > $dirLen and $et->Warn('Truncated CTMD record'), last;
+        $et->VerboseDir("CTMD type $type", undef, $size - 6);
+        HexDump($dataPt, 6,     # dump 6-byte header
+            Start  => $pos + 6,
+            Addr   => $$dirInfo{Base} + $pos + 6,
+            Prefix => $$et{INDENT},
+        ) if $verbose > 2;
+        if ($$tagTablePtr{$type}) {
+            $et->HandleTag($tagTablePtr, $type, undef,
+                DataPt  => $dataPt,
+                Base    => $$dirInfo{Base},
+                Start   => $pos + 12,
+                Size    => $size - 12,
+            );
+        } elsif ($verbose) {
+            $et->VerboseDump($dataPt, Len=>$size-12, Start=>$pos+12, DataPos=>$$dirInfo{Base});
+        }
+        $pos += $size;
+    }
+    $et->Warn('Error parsing Canon CTMD data', 1) if $pos != $dirLen;
+    return 1;
+}
+
+#------------------------------------------------------------------------------
 # Process a creative filter data
 # Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
@@ -6762,5 +9807,5 @@
 sub ProcessFilters($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $pos = $$dirInfo{DirStart};
@@ -6768,9 +9813,9 @@
     my $dataPos = $$dirInfo{DataPos} || 0;
     my $end = $pos + $dirLen;
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
 
     return 0 if $dirLen < 8;
     my $numFilters = Get32u($dataPt, $pos + 4);
-    $verbose and $exifTool->VerboseDir('Creative Filter', $numFilters);
+    $verbose and $et->VerboseDir('Creative Filter', $numFilters);
     $pos += 8;
     my ($i, $j, $err);
@@ -6780,7 +9825,7 @@
         # 4 bytes - filter data length
         # 4 bytes - number of parameters:
-        # |  4 bytes - paramter ID
-        # |  4 bytes - paramter value count
-        # |  4 bytes * count - paramter values (NC)
+        # |  4 bytes - parameter ID
+        # |  4 bytes - parameter value count
+        # |  4 bytes * count - parameter values (NC)
         $pos + 12 > $end and $err = "Truncated data for filter $i", last;
         my $fnum = Get32u($dataPt, $pos); # (is this an index or an ID?)
@@ -6789,5 +9834,5 @@
         my $nxt = $pos + 4 + $size;
         $nxt > $end and $err = "Invalid size ($size) for filter $i", last;
-        $verbose and $exifTool->VerboseDir("Filter $fnum", $nparm, $size);
+        $verbose and $et->VerboseDir("Filter $fnum", $nparm, $size);
         $pos += 12;
         for ($j=0; $j<$nparm; ++$j) {
@@ -6798,5 +9843,5 @@
             $pos + 4 * $count > $end and $err = "Truncated value for filter $i param $j", last;
             my $val = ReadValue($dataPt, $pos, 'int32s', $count, 4 * $count);
-            $exifTool->HandleTag($tagTablePtr, $tag, $val,
+            $et->HandleTag($tagTablePtr, $tag, $val,
                 DataPt  => $dataPt,
                 DataPos => $dataPos,
@@ -6808,5 +9853,5 @@
         $pos = $nxt;    # step to next filter
     }
-    $err and $exifTool->Warn($err, 1);
+    $err and $et->Warn($err, 1);
     return 1;
 }
@@ -6818,11 +9863,11 @@
 sub WriteCanon($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access to autoload this package
-    my $dirData = Image::ExifTool::Exif::WriteExif($exifTool, $dirInfo, $tagTablePtr);
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access to autoload this package
+    my $dirData = Image::ExifTool::Exif::WriteExif($et, $dirInfo, $tagTablePtr);
     # add footer which is written by some Canon models (format of a TIFF header)
     if (defined $dirData and length $dirData and $$dirInfo{Fixup}) {
         $dirData .= GetByteOrder() . Set16u(42) . Set32u(0);
-        $dirInfo->{Fixup}->AddFixup(length($dirData) - 4);
+        $$dirInfo{Fixup}->AddFixup(length($dirData) - 4);
     }
     return $dirData;
@@ -6849,5 +9894,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -6866,5 +9911,5 @@
 =item L<http://homepage3.nifty.com/kamisaka/makernote/makernote_canon.htm>
 
-=item (...plus lots of testing with my 300D and my daughter's A570IS!)
+=item (...plus lots of testing with my 300D, A570IS and G12!)
 
 =back
@@ -6876,7 +9921,8 @@
 figuring out the 20D and 30D FileNumber, Denny Priebe for figuring out a
 couple of 1D tags, and Michael Tiemann, Rainer Honle, Dave Nicholson, Chris
-Huebsch, Ger Vermeulen, Darryl Zurn, D.J. Cristi, Bogdan and Vesa Kivisto for
-decoding a number of new tags.  Also thanks to everyone who made contributions
-to the LensType lookup list or the meanings of other tag values.
+Huebsch, Ger Vermeulen, Darryl Zurn, D.J. Cristi, Bogdan, Vesa Kivisto and
+Kai Harrekilde-Petersen for decoding a number of new tags.  Also thanks to
+everyone who made contributions to the LensType lookup list or the meanings
+of other tag values.
 
 =head1 SEE ALSO
